import 'package:code_id_flutter/code_utils/extensions/extensions.dart';

/// Represents a generic pair of two values.
class Pair<T, U> {
  Pair(this.left, this.right);

  final T? left;
  final U? right;

  @override
  String toString() => '($left, $right)';
}

extension PairExtensions<T> on Pair<T, T> {
  List<T?> toList() => listOf([left, right]);
}
